(* Title:  "MathEngBasic/tactic.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- fun result, fun creates_assms -----------------------------------------------------";
"----------- fun subst_adapt_to_type -----------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

"----------- fun result, fun creates_assms ---------------------------------------------------";
"----------- fun result, fun creates_assms ---------------------------------------------------";
"----------- fun result, fun creates_assms ---------------------------------------------------";
val thm'' = ("real_mult_div_cancel2", @{thm real_mult_div_cancel2});
val (f, res) = (@{term "a * x / (b * x) :: real"}, (@{term "a / b :: real"}, [@{term "k \<noteq> (0 :: real)"}]: term list))
;
Rewrite': ThyC.id * Rewrite_Ord.id * Rule_Set.T * bool * ThmC.T * term * Calc.result -> Tactic.T;
val tac = Rewrite' ("Diff", "dummy_ord", Rule_Set.empty, true, thm'', f, res)
;
if (Tactic.result ctxt tac |> UnparseC.term @{context}) = "a / b" then () else error "creates_assms CHANGED";
if (Tactic.creates_assms ctxt tac |> UnparseC.terms @{context}) = "[k \<noteq> 0]" then () else error "creates_assms CHANGED";


"----------- fun subst_adapt_to_type -----------------------------------------------------------";
"----------- fun subst_adapt_to_type -----------------------------------------------------------";
"----------- fun subst_adapt_to_type -----------------------------------------------------------";
val subs = ["(''bdv'', x)"];

val [((Free ("bdv", T1)), Free ("x", T2))] = subst_adapt_to_type ctxt subs;
if T1 = HOLogic.realT andalso T2 = HOLogic.realT
then () else error "subst_adapt_to_type CHANGED";

